Index: GTP/trunk/Lib/Vis/Preprocessing/src/Mesh.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Mesh.h	(revision 991)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Mesh.h	(revision 1001)
@@ -70,9 +70,8 @@
 
   /// Default constructor
-  Mesh():mVertices(), mFaces(), mMaterial(NULL), mKdTree(NULL) {}
-  
+  Mesh():mVertices(), mFaces(), mMaterial(NULL), mKdTree(NULL), mId(0) {}
+
   /// Constructor with container preallocation
-  Mesh(const int vertices,
-       const int faces):
+  Mesh(const int vertices, const int faces):
     mFaces(),
     mMaterial(NULL),
@@ -80,10 +79,29 @@
     mVertices(),
     mIsConvex(false),
-    mIsWatertight(false)
+    mIsWatertight(false),
+	mId(0)
   {
     mVertices.reserve(vertices);
     mFaces.reserve(faces);
   }
-  
+
+  /** Constructor setting a unqiue mesh id.
+  */
+  Mesh(const int id);
+
+  /** Setting unique mesh id and using preallocation.
+  */
+  Mesh(const int id, const int vertices, const int faces);
+
+  /** Copy constructor making a deep copy of the faces.
+  */
+  Mesh(const Mesh &rhs);
+
+  /** Assignement operator.
+	@note does not copy id
+	@note preprocess may be necessary
+  */
+  Mesh& operator=(const Mesh& m);
+
   ~Mesh() {
     for (int i=0; i < mFaces.size(); i++)
@@ -113,55 +131,68 @@
 
   void ComputeBoundingBox();
+
+  /** This function must be called after creating the mesh
+	because it creates the local kd tree and the bounding box.
+	*/
   void Preprocess();
 
-  /** Axis aligned bounding box of the mesh in local mesh coordinates */
+  /** Applies transformation to the mesh.
+	@note: meshkdtree will most likely be outdated after transformation, thus 
+	another preprocess might be necessary.	
+	*/
+  void ApplyTransformation(const Matrix4x4 &m);
+
+  /** Axis aligned bounding box of the mesh in local mesh coordinates.
+  */
   AxisAlignedBox3 mBox;
   
-  /** Vertices forming the mesh */
+  /** Vertices forming the mesh.
+  */
   VertexContainer mVertices;
   
-  /** Patches forming the mesh */
+  /** Patches forming the mesh.
+  */
   FaceContainer mFaces;
   
-  /** Global mesh material */
+  /** Global mesh material.
+  */
   Material *mMaterial;
   
-  /** true if the mesh is a convex mesh */
+  /** true if the mesh is a convex mesh.
+  */
   bool mIsConvex;
 
-  /** true if the mesh is a convex mesh */
+  /** true if the mesh is a convex mesh.
+  */
   bool mIsWatertight;
 
   MeshKdTree *mKdTree;
-  
-  int
-  CastRay(
-					Ray &ray,
-					MeshInstance *instance
+
+  int
+  CastRay(Ray &ray, MeshInstance *instance);
+	
+  int
+  CastRayToSelectedFaces(
+						 Ray &ray,
+						 const vector<int> &faces,
+						 Intersectable *instance
+						 );
+	
+  int
+  CastRayToFace(
+				const int faceIndex,
+				Ray &ray,
+				float &nearestT,
+				int &nearestFace,
+				Intersectable *instance
+				);
+	
+  
+  int
+  RayFaceIntersection(const int faceIndex,
+					const Ray &ray,
+					float &t,
+					const float nearestT
 					);
-	
-  int
-  CastRayToSelectedFaces(
-												 Ray &ray,
-												 const vector<int> &faces,
-												 Intersectable *instance
-												 );
-	
-  int
-  CastRayToFace(
-								const int faceIndex,
-								Ray &ray,
-								float &nearestT,
-								int &nearestFace,
-								Intersectable *instance
-								);
-	
-  
-  int
-  RayFaceIntersection(const int faceIndex,
-											const Ray &ray,
-											float &t,
-											const float nearestT
-											);
   
   Plane3 GetFacePlane(const int faceIndex);
@@ -177,21 +208,33 @@
 							   const int maxTries
 							   );
-  
+ 
+  /** Returns unique mesh id.
+  */
+  int GetId() const
+  {
+	  return mId;
+  }
+
   virtual ostream &Describe(ostream &s) {
 	return s<<"Mesh #vertices="<<(int)mVertices.size()<<" #faces="<<(int)mFaces.size();
   }
   
-  /** Creates a mesh from a axis aligned bounding box
+  /** Creates a mesh from a axis aligned bounding box.
+      The mesh is handled from the resource manager.
   */
   friend Mesh *CreateMeshFromBox(const AxisAlignedBox3 &box);
+
+ 
+protected:
+
+  /// Unique id of this mesh.
+  int mId;
 };
 
 
 class MeshInstance : public Intersectable {
-protected:
-  Mesh *mMesh;
-  
+
 public:
-  MeshInstance(Mesh *mesh):Intersectable(), mMesh(mesh)
+  MeshInstance(Mesh *mesh):Intersectable(), mMesh(mesh), mMaterial(NULL)
   {
   }
@@ -238,24 +281,35 @@
 	}
 	
+	/** Sets the material. this overrides the material from 
+		the mesh itself.
+	*/
+	void SetMaterial(Material *mat);
+
+	/** Returns the material of this mesh instance.
+		if not defined, returns the material of the mesh itself.
+	*/
+	Material *GetMaterial() const;
+
+protected:
+
+	Mesh *mMesh;
+	/** This material overrides the mesh material;
+	*/
+	Material *mMaterial;  
 };
 
 
+/** This mesh instance includes a world transform. Use this
+	class if the same mesh should be instantiated on different places.
+*/
 class TransformedMeshInstance : public MeshInstance
 {
 public:
-  TransformedMeshInstance(Mesh *mesh):MeshInstance(mesh)
-  {
-    mWorldTransform = IdentityMatrix();
-  }
-  
-  virtual AxisAlignedBox3 GetBox() {
-    return Transform(mMesh->mBox,
-		     mWorldTransform);
-  }
-  
-  virtual int
-  CastRay(
-	  Ray &ray
-	  );
+  TransformedMeshInstance(Mesh *mesh);
+  
+  virtual AxisAlignedBox3 GetBox();
+   
+  
+  virtual int CastRay(Ray &ray);
 
   virtual int Type() const { return TRANSFORMED_MESH_INSTANCE; }
@@ -263,6 +317,20 @@
   int GetRandomSurfacePoint(Vector3 &point, Vector3 &normal);
 
-private:
-  Matrix4x4 mWorldTransform;
+  /** Transforms this mesh instance by m.
+  */
+  void ApplyWorldTransform(const Matrix4x4 &m);
+
+  /** Loads the transformation matrix into this mesh instance.
+  */
+  void LoadWorldTransform(const Matrix4x4 &m);
+
+  /** The transformation is returned in m.
+  */
+  void GetWorldTransform(Matrix4x4 &m);
+
+protected:
+
+	/// the transformation matrix    
+	Matrix4x4 mWorldTransform;
   
 };
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 997)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 1001)
@@ -1168,4 +1168,10 @@
 				 "1000");
 
+  RegisterOption("RenderSampler.visibleThreshold",
+				 optInt,
+				 "render_sampler_visible_threshold=",
+				 "0");
+
+
    RegisterOption("RenderSampler.useOcclusionQueries",
 				 optBool,
@@ -1178,5 +1184,8 @@
 				 "100000");
   
-  RegisterOption("VssPreprocessor.testBeamSampling", optBool, "beam_sampling", "false");
+  RegisterOption("VssPreprocessor.testBeamSampling", 
+				optBool, 
+				"beam_sampling", 
+				"false");
 
   RegisterOption("VssPreprocessor.vssSamples",
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellBsp.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellBsp.cpp	(revision 882)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellBsp.cpp	(revision 1001)
@@ -647,5 +647,6 @@
 	for (int i = 0; i < limit; ++i)
 	{
-		Intersectable *object = objects[i];//*it;
+		Intersectable *object = objects[i];
+
 		Mesh *mesh = NULL;
 
@@ -658,5 +659,20 @@
 			mesh = dynamic_cast<ViewCell *>(object)->GetMesh();
 			break;
-			// TODO: handle transformed mesh instances
+		case Intersectable::TRANSFORMED_MESH_INSTANCE:
+			{
+				TransformedMeshInstance *mi = 
+					dynamic_cast<TransformedMeshInstance *>(object);
+
+				if (!mi->GetMesh())
+					break;
+
+				mesh = new Mesh(*mi->GetMesh());
+
+				Matrix4x4 m;
+				mi->GetWorldTransform(m);
+				mesh->ApplyTransformation(m);
+				
+				break;
+			}
 		default:
 			Debug << "intersectable type not supported" << endl;
@@ -667,10 +683,12 @@
 		{
 			if (addToBbox)
-			{
 				mBox.Include(object->GetBox()); // add to BSP tree aabb
-			}
-		
+				
 			AddMeshToPolygons(mesh, polys, mOutOfBoundsCell);
-		}
+
+			// cleanup
+			if (object->Type() == Intersectable::TRANSFORMED_MESH_INSTANCE)
+				DEL_PTR(mesh);
+		}	
 	}
 
@@ -2851,5 +2869,4 @@
 	mPolys.reserve(rhs.mPolys.size());
 	mPlanes.reserve(rhs.mPolys.size());
-
 
 	PolygonContainer::const_iterator it, it_end = rhs.mPolys.end();
Index: GTP/trunk/Lib/Vis/Preprocessing/src/LogManager.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/LogManager.h	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/LogManager.h	(revision 1001)
@@ -0,0 +1,52 @@
+#ifndef _LogManager_H__
+#define _LogManager_H__
+
+#include <vector>
+#include <fstream>
+#include <iostream>
+
+#include "Containers.h"
+
+
+namespace GtpVisibilityPreprocessor {
+
+
+/** Log manager controlling the debug output.
+	This class defines the pattern of singleton to assure that
+	there is always only one log manager.
+*/
+class LogManager {
+
+public:
+
+	/** Returns the resource manager as a singleton.
+	*/
+	static LogManager *GetSingleton();
+
+
+protected:
+
+	/** Default constructor. The constructor is protected
+		to have control over instantiation using the 
+		singleton pattern.
+	*/
+	LogManager();
+
+	~LogManager();
+  
+	void LogMessage(const std::string &str);
+
+protected:
+
+	std::ofstream mOutStream;
+
+private:
+
+	static LogManager *sLogManager;
+	
+};
+
+
+}
+
+#endif
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ResourceManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ResourceManager.cpp	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ResourceManager.cpp	(revision 1001)
@@ -0,0 +1,109 @@
+#include "ResourceManager.h"
+#include "Mesh.h"
+
+namespace GtpVisibilityPreprocessor {
+
+ResourceManager *ResourceManager::sResourceManager = NULL;
+
+
+ResourceManager *ResourceManager::GetSingleton()
+{Debug << "here1" << endl;
+	if (!sResourceManager)
+	{
+		Debug << "here888" << endl;
+		sResourceManager = new ResourceManager();
+	}
+
+  Debug << "here999" << endl;
+	return sResourceManager;
+}
+
+
+ResourceManager::ResourceManager()
+{
+}
+
+ResourceManager::~ResourceManager()
+{
+	cout << "here839 " << mMeshes.size() << endl;
+
+	MeshMap::iterator mit, mit_end = mMeshes.end();
+	for (mit = mMeshes.begin(); mit != mMeshes.end(); ++ mit)
+	{
+		cout << "mesh: " << (*mit).first << " " << (*mit).second << endl;
+		DEL_PTR((*mit).second);
+	}
+}
+
+void ResourceManager::DelSingleton()
+{
+	cout << "here11" << endl;
+	DEL_PTR(sResourceManager);
+}
+
+/*Mesh *ResourceManager::CreateMesh(const string meshName)
+{
+	Mesh *mesh = new Mesh();
+	mMeshes[meshName] = mesh;
+	
+	return mesh;
+}*/
+
+
+Mesh *ResourceManager::GetOrCreateMesh(const string meshName)
+{Debug << "here2" << endl;
+	Mesh *mesh = NULL;
+
+	if (!(mesh = FindMesh(meshName.c_str())))
+	{
+		mesh = new Mesh();
+		mMeshes[meshName.c_str()] = mesh;
+	}
+
+	return mesh;
+}
+
+
+/*
+bool ResourceManager::InsertMesh(Mesh *mesh, const string meshName)
+{
+	Mesh *mesh = NULL;
+
+	if (FindMesh(meshName.c_str()))
+		return false;
+
+	mMeshes[meshName.c_str()] = mesh;
+	
+	return mesh;
+}
+*/
+
+Mesh *ResourceManager::FindMesh(const string &name) const
+{Debug << "here3" << endl;
+	MeshMap::const_iterator mit = mMeshes.find(name.c_str());
+
+	if (mit != mMeshes.end()) 
+	{
+		return (*mit).second;
+	}
+
+	return NULL;
+}
+
+
+bool ResourceManager::DestroyMesh(const string &meshName)
+{
+	if (!FindMesh(meshName))
+	{
+		Mesh *mesh = mMeshes[meshName.c_str()];
+
+		mMeshes.erase(meshName.c_str());
+		DEL_PTR(mesh);
+
+		return true;
+	}
+
+	return false;
+}
+
+}
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 997)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Preprocessor.cpp	(revision 1001)
@@ -20,5 +20,5 @@
 
 
-// HACK
+// HACK: Artificially modify scene to watch rendercost changes
 static void AddGeometry(SceneGraph *scene)
 {
Index: GTP/trunk/Lib/Vis/Preprocessing/src/glInterface.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/glInterface.h	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/glInterface.h	(revision 1001)
@@ -0,0 +1,27 @@
+//Copyright and Disclaimer:
+//This code is copyright Vienna University of Technology, 2004.
+
+#ifndef NO_PRAGMA_ONCE
+#pragma once
+#endif
+
+#ifndef GLINTERFACE_H
+#define GLINTERFACE_H
+
+
+//includes an openGL extension header file
+//http://glew.sourceforge.net/
+#include "GL/glew.h"
+//includes the glut header file
+#include "GL/glut.h"
+
+//includes windows specific stuff
+#ifdef _WIN32
+	#include "GL/wglew.h"
+#else
+//include linux specific stuff
+	#include "GL/glxew.h"
+#endif	
+
+
+#endif // GLINTERFACE_H
Index: GTP/trunk/Lib/Vis/Preprocessing/src/OcclusionQuery.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/OcclusionQuery.h	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/OcclusionQuery.h	(revision 1001)
@@ -0,0 +1,39 @@
+#ifndef _OcclusionQuery_H__
+#define _OcclusionQuery_H__
+
+#include <vector>
+
+
+namespace GtpVisibilityPreprocessor { 
+
+/** This class is an implementation for occlusion queries.
+	@remark the class encapsulates occlusion query calls.
+*/
+class OcclusionQuery
+{
+public:
+	
+	OcclusionQuery();
+
+	virtual ~OcclusionQuery();
+
+	virtual bool ResultAvailable() const;
+	virtual unsigned int GetQueryResult() const;
+	virtual void BeginQuery();
+	virtual void EndQuery();
+	
+	static void GenQueries(std::vector<OcclusionQuery *> &queries, const int numQueries);
+
+	unsigned int GetQueryId() const;
+
+
+protected:
+
+	OcclusionQuery(const unsigned int idx);
+	static bool sUseArbQueries;
+
+	unsigned int mId;
+};
+
+} // namespace 
+#endif // OcclusionQuery_H
Index: GTP/trunk/Lib/Vis/Preprocessing/src/X3dExporter.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/X3dExporter.h	(revision 863)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/X3dExporter.h	(revision 1001)
@@ -85,4 +85,7 @@
 
   virtual void
+  ExportTransformedMeshInstance(TransformedMeshInstance *mi);
+
+  virtual void
   ExportIntersectable(Intersectable *object);
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/RenderSampler.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/RenderSampler.cpp	(revision 1000)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/RenderSampler.cpp	(revision 1001)
@@ -19,8 +19,14 @@
 	int histoMaxVal = 0;
 	int histoIntervals = 0;
-	
+	int threshold;
+	bool useOcclusionQueries;
+
     environment->GetIntValue("Preprocessor.histogram.maxValue", histoMaxVal);
 	environment->GetIntValue("Preprocessor.histogram.intervals", histoIntervals);
+	environment->GetIntValue("RenderSampler.visibleThreshold", threshold);
+	environment->GetBoolValue("RenderSampler.useOcclusionQueries", useOcclusionQueries);
 
+	Debug << "************* render sampler ****************" << endl;
+	Debug << "threshold: " << threshold << endl;
 	const int intervals = histoIntervals;
 
@@ -28,8 +34,8 @@
 
 	vector<RenderCostSample> samples;
-  
+  	while (1){cout <<"q";}
 	if (renderer)
 	{
-		renderer->SampleRenderCost(mSamples, samples);
+		renderer->SampleRenderCost(mSamples, samples, useOcclusionQueries, threshold);
 	}
 
@@ -45,4 +51,5 @@
 	vector<int> histogram(intervals);
   
+
 	// initialise histogram
 	for (int i = 0; i < intervals; ++ i)
Index: GTP/trunk/Lib/Vis/Preprocessing/src/FromPointVisibilityTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/FromPointVisibilityTree.cpp	(revision 970)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/FromPointVisibilityTree.cpp	(revision 1001)
@@ -288,5 +288,5 @@
 	for (int i = 0; i < limit; ++i)
 	{
-		Intersectable *object = objects[i];//*it;
+		Intersectable *object = objects[i];
 		Mesh *mesh = NULL;
 
@@ -299,5 +299,20 @@
 			mesh = dynamic_cast<ViewCell *>(object)->GetMesh();
 			break;
-			// TODO: handle transformed mesh instances
+		case Intersectable::TRANSFORMED_MESH_INSTANCE:
+			{          
+				TransformedMeshInstance *mi = 
+					dynamic_cast<TransformedMeshInstance *>(object);
+
+				if (!mi->GetMesh())
+					break;
+
+				mesh = new Mesh(*mi->GetMesh());
+
+				Matrix4x4 m;
+				mi->GetWorldTransform(m);
+				mesh->ApplyTransformation(m);
+
+				break;
+			}
 		default:
 			Debug << "intersectable type not supported" << endl;
@@ -309,4 +324,8 @@
 			mBox.Include(object->GetBox()); // add to BSP tree aabb
 			AddMeshToPolygons(mesh, polys, NULL);
+
+			// cleanup
+			if (object->Type() == Intersectable::TRANSFORMED_MESH_INSTANCE)
+				DEL_PTR(mesh);
 		}
 	}
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GzBinFileInputStream.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GzBinFileInputStream.cpp	(revision 975)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GzBinFileInputStream.cpp	(revision 1001)
@@ -85,4 +85,6 @@
 	//mStream.open(myFileName, ios::binary);
 	mStream.open(myFileName);
+
+	delete [] myFileName;
 }
 
@@ -144,5 +146,5 @@
 	unsigned int result = mStream.gcount();
 	mCurrentPos = mStream.tellg();
-	//GtpVisibilityPreprocessor::Debug << "here1001 " << maxToRead << " haha " << toFill << " " << result << endl;
+	//GtpVisibilityPreprocessor::Debug << "stream: " << maxToRead << " " << toFill << " " << result << endl;
 
 	return result;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 997)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 1001)
@@ -15,4 +15,5 @@
 #include "PreprocessorThread.h"
 #include "RenderSampler.h"
+#include "ResourceManager.h"
 
 #include <QApplication>
@@ -143,12 +144,17 @@
   
 
+  int returnCode = 0;
+
   if (app)
-	return app->exec();
+	 returnCode = app->exec();
 
-  // clean up
+   // clean up
   DEL_PTR(p);
   DEL_PTR(environment);
+  MeshManager::DelSingleton();
+  MaterialManager::DelSingleton();
 
-  return 0;
+
+  return returnCode;
 }
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ResourceManager.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ResourceManager.h	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ResourceManager.h	(revision 1001)
@@ -0,0 +1,156 @@
+#ifndef _ResourceManager_H__
+#define _ResourceManager_H__
+
+#include <vector>
+#include <string>
+
+//#include "Containers.h"
+#include "Mesh.h"
+#include "Material.h"
+
+namespace GtpVisibilityPreprocessor {
+
+
+/** Resource manager controlling loading and destroying of resources.
+	
+	@note Resources must be created using the manager to assure that
+	they are destroyed properly, otherwise the developer has the
+	responsibility to destroy them himself.
+
+	@note This class defines the pattern of singleton to assure that
+	there is always only one resource manager.
+*/
+template <typename T> class ResourceManager
+{
+
+public:
+
+	/** Returns the resource manager as a singleton.
+	*/
+	static ResourceManager<T> *GetSingleton()
+	{
+		if (!sResourceManager)
+		{
+			sResourceManager = new ResourceManager();
+		}
+
+		return sResourceManager;
+	}
+
+	static void DelSingleton()
+	{
+		DEL_PTR(sResourceManager);
+	}
+
+	/** Creates new entry with a unique id
+	*/
+	T *CreateResource()
+	{
+		const int id = CreateUniqueId();
+
+		T *resource = new T(id);
+		mEntries[id] = resource;
+		
+		return resource;
+	}
+
+	
+	/** Searches for the mesh with the given name.
+		@returns mesh or NULL if mesh was not found.
+	*/
+	T *FindEntry(const int id) const
+	{
+		std::map<int, T *>::const_iterator mit = mEntries.find(id);
+
+		if (mit != mEntries.end()) 
+		{
+			return (*mit).second;
+		}
+
+		return NULL;
+	}
+
+	/** Destroys mesh with the given name.
+		@returns true if the mesh was found, false if not
+	*/
+	bool DestroyEntry(const int id)
+	{	
+		if (!FindEntry(id))
+		{
+			T *resource = mEntries[id];
+
+			mEntries.erase(id);
+			DEL_PTR(resource);
+
+			return true;
+		}
+		
+		return false;
+	}
+	
+
+	/** Returns size of resource container.
+	*/
+	const int GetSize()
+	{
+		return (int)mEntries.size();
+	}
+
+protected:
+
+	/** Default constructor. The constructor is protected
+		to have control over instantiation using the 
+		singleton pattern.
+	*/
+	ResourceManager<T>()
+	{}
+
+	/** Release resources.
+	*/
+	~ResourceManager<T>()
+	{
+		std::map<int, T *>::iterator mit, mit_end = mEntries.end();
+
+		for (mit = mEntries.begin(); mit != mEntries.end(); ++ mit)
+		{
+			cout << "mesh: " << (*mit).first << " " << (*mit).second << endl;
+			DEL_PTR((*mit).second);
+		}
+	}
+  
+	/** Copy constructor.
+	*/
+    ResourceManager<T>(const ResourceManager<T>& source)
+    {
+    }
+
+	 /** Helper function returning unique id for resource.
+	 */
+	static int CreateUniqueId()
+	{
+		return sCurrentId ++;
+	}
+
+protected:
+
+	/// the resource container
+	std::map<int, T *> mEntries;
+
+private:
+
+	static ResourceManager<T> *sResourceManager;
+	static int sCurrentId;
+};
+
+// only instance of the resource manager
+template <typename T> ResourceManager<T> *ResourceManager<T>::sResourceManager = NULL;
+template <typename T> int ResourceManager<T>::sCurrentId = 0;
+
+/// This type is responsible for creation and disposal the meshes
+typedef ResourceManager<Mesh> MeshManager;
+/// This type is esponsible for creation and disposal of the materials.
+typedef ResourceManager<Material> MaterialManager;
+
+}
+
+#endif
Index: GTP/trunk/Lib/Vis/Preprocessing/src/X3dExporter.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/X3dExporter.cpp	(revision 863)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/X3dExporter.cpp	(revision 1001)
@@ -198,16 +198,19 @@
 X3dExporter::ExportIntersectable(Intersectable *object)
 {
-  switch (object->Type()) {
-  case Intersectable::MESH_INSTANCE:
-  case Intersectable::TRANSFORMED_MESH_INSTANCE:
-    ExportMeshInstance((MeshInstance *)object);
-	break;
-  case Intersectable::VIEW_CELL:
-	ExportViewCell((ViewCell *)object);
-    break;
-  default:
-    cerr<<"Sorry the export for object not yet defined"<<endl;
-    break;
-  }
+	switch (object->Type()) 
+	{
+	case Intersectable::MESH_INSTANCE:
+		ExportMeshInstance((MeshInstance *)object);
+		break;
+	case Intersectable::TRANSFORMED_MESH_INSTANCE:
+		ExportTransformedMeshInstance(dynamic_cast<TransformedMeshInstance *>(object));
+		break;
+	case Intersectable::VIEW_CELL:
+		ExportViewCell((ViewCell *)object);
+		break;
+	default:
+		cerr << "Sorry the export for object not yet defined" << endl;
+		break;
+	}
 }
 
@@ -223,4 +226,17 @@
 
 
+void
+X3dExporter::ExportTransformedMeshInstance(TransformedMeshInstance *mi)
+{
+	Mesh mesh(*mi->GetMesh());
+
+	Matrix4x4 m;
+	mi->GetWorldTransform(m);
+	mesh.ApplyTransformation(m);
+
+	ExportMesh(&mesh);
+}
+
+
 void 
 X3dExporter::ExportViewCells(const ViewCellContainer &viewCells)
@@ -231,4 +247,5 @@
 		ExportViewCell(*it);
 }
+
 
 void 
@@ -321,4 +338,5 @@
       b = RandomValue(0.5, 1.0);
     }
+    
   stream<<"<Material diffuseColor=\""<<r<<" "<<g<<" "<<b<<
     "\" specularColor=\"0.0 0.0 0.0\"/>"<<endl;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.h	(revision 997)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.h	(revision 1001)
@@ -2,6 +2,8 @@
 #define __GLRENDERER_H
 
+//#include "glInterface.h"
 #include <QtOpenGL>
 #include <QWaitCondition>
+
 //#include <QGLPixelBuffer>
 
@@ -26,4 +28,6 @@
 class GlRendererBuffer;
 class BeamSampleStatistics;
+class OcclusionQuery;
+class TransformedMeshInstance;
 
 struct VssRayContainer;
@@ -107,5 +111,5 @@
   QWaitCondition mRenderingFinished;
   
-  vector<unsigned int> mOcclusionQueries;
+  vector<OcclusionQuery *> mOcclusionQueries;
   
   GlRenderer(SceneGraph *sceneGraph,
@@ -120,4 +124,5 @@
   void RenderViewCell(ViewCell *vc);
   void RenderMeshInstance(MeshInstance *mi);
+  void RenderTransformedMeshInstance(TransformedMeshInstance *mi);
   void RenderMesh(Mesh *m);
   void SetupMaterial(Material *m);
@@ -157,14 +162,25 @@
 
 
-  void
-  EvalRenderCostSample(
-					   RenderCostSample &sample
-					   );
-
-  void
-  SampleRenderCost(
-				   const int n,
-				   vector<RenderCostSample> &samples
-				   );
+	/** Evaluates render cost of a point sample.
+		@param sample the render cost sample to be evaluated
+		@param useOcclusionQueries if occlusion queries should be used or item buffer
+		@param threshold number of pixels / samples from where an object is considered visible.
+	*/
+	void EvalRenderCostSample(RenderCostSample &sample,
+							  const bool useOcclusionQueries,
+							  const int threshold);
+
+	/** Evaluates render cost of a number of point samples. The point samples
+		are distributed uniformly over the defined view space.
+
+		@param numSamples the number of point samples taken
+		@param samples stores the taken point samples in a container
+		@param useOcclusionQueries if occlusion queries should be used or item buffer
+		@param threshold number of pixels / samples from where an object is considered visible.
+	*/
+	void SampleRenderCost(const int numSamples, 
+						  vector<RenderCostSample> &samples,
+						  const bool useOcclusionQueries,
+						  const int threshold = 0);
 
 
@@ -234,5 +250,9 @@
 									 Intersectable *sourceObject);
 
+	/** Evaluates query for one direction using item buffer.
+	*/
 	void EvalQueryWithItemBuffer();
+	/** Evaluates query for one direction using occlusion queries.
+	*/
 	void EvalQueryWithOcclusionQueries();
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Containers.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Containers.h	(revision 863)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Containers.h	(revision 1001)
@@ -38,11 +38,7 @@
 typedef vector<ViewCell *> ViewCellContainer;
 
-/** Container for ViewCell pointers primarily for the use within the kDTree and
-    BSP hierarchies */
-//typedef vector<MeshInstance *> MeshInstanceContainer;
-
 /** Container for HierarchyNodes pointers primarily for the use within the kDTree and
-    BSP hierarchies */
-
+    BSP hierarchies 
+	*/
 typedef vector<HierarchyNode *> NodeContainer;
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.h	(revision 860)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VrmlExporter.h	(revision 1001)
@@ -85,4 +85,7 @@
 
   virtual void
+  ExportTransformedMeshInstance(TransformedMeshInstance *mi);
+
+  virtual void
   ExportIntersectable(Intersectable *object);
 
